// #autoload
// #name = KickReason
// #category = Sonic's Scripts
// #version = 1.5
// #date = January 10, 2004
// #status = beta
// #description = Kick or warn a player with a reason.  Bind the KillReason HUD to an in game key and you must have admin or superadmin access on the server.  Pick the player, and your message and warn or kick away.
// #warrior = sonic9k
// #author = sonic9k
// #email = sonic9k@jobielan.com
//

if (isFile ("prefs/KickReasonPrefs.cs"))
	exec ("prefs/KickReasonPrefs.cs");
else
{
	$KickReason::Delay = 20;
	$KickReason::Bottom = true;
	export ("$KickReason::*", "prefs/KickReasonPrefs.cs", false);
}



$KickReasonVars::KeyBindsAdded = false;
$KickReasonVars::Up = false;
$KickReasonVars::SelectedClientId = -1;
$KickReasonVars::Line1 = "";
$KickReasonVars::Line2 = "";


function KickWithAReason (%warn)
{
	if ($KickReasonVars::selectedClientId == -1)
		return;

	%msg = (%warn) ? "-- W A R N I N G ! -- W A R N I N G ! --\n" :
			 "-- K I C K I N G ! -- K I C K I N G ! --\n";
	%lines = 1;

	if (strlen ($KickReasonVars::Line1) > 0)
	{
		%msg = %msg @ $KickReasonVars::Line1 @ "\n";
		%lines++;
	}

	if (strlen ($KickReasonVars::Line2) > 0)
	{
		%msg = %msg @ $KickReasonVars::Line2 @ "\n";
		%lines++;
	}

	commandToServer ('KickReason', $KickReasonVars::SelectedClientId, %msg,
			 %warn, $KickReason::Delay, %lines, $KickReason::Bottom);
}

function ShowKickReasonGui (%val)
{
	if (%val)
	{
		// Create dialog if not done yet
		if (!isObject (KickReasonGui))
			CreateKickReasonGui();

		if ($KickReasonVars::Up)
			Canvas.popDialog (KickReasonGui);
		else
			Canvas.pushDialog (KickReasonGui);
	}
}

function HideKickReasonGui()
{
	Canvas.popDialog (KickReasonGui);
}


function KickReasonGui::onWake (%this)
{
	$KickReasonVars::Up = true;
	KickReason_Player_Popup.clear();

	for (%i=0; %i < PlayerListGroup.getCount(); %i++)
	{
		%p = PlayerListGroup.getObject (%i);
		if (%p == -1)
			break;

		KickReason_Player_Popup.add (%p.name, %p.clientId);
	}

	// Set the slider value
	KickReason_Delay_slider.setValue ($KickReason::Delay);
}

function KickReasonGui::onSleep (%this)
{
	$KickReasonVars::Up = false;
	$KickReasonVars::SelectedClientId = -1;
	$KickReasonVars::Line1 = "";
	$KickReasonVars::Line2 = "";
}

function KickReason_Player_Popup::onSelect (%this, %id, %text)
{
	$KickReasonVars::SelectedClientId = %id;
}

package KickReason
{
	function OptionsDlg::onWake (%this)
	{
		// Add keybinds
		if (!$KickReasonVars::KeyBindsAdded)
		{
			$RemapName[$RemapCount] = "Kick Reason Hud";
			$RemapCmd[$RemapCount] = "ShowKickReasonGui";
			$RemapCount++;

			$KickReasonVars::KeyBindsAdded = 1;
		}

		// Call the parent
		parent::onWake (%this);
	}

	function quit()
	{
		export ("$KickReason::*", "prefs/KickReasonPrefs.cs", false);
		parent::quit();
	}
};

activatePackage ("KickReason");


function CreateKickReasonGui()
{

//--- OBJECT WRITE BEGIN ---
new GuiControl(KickReasonGui) {
	profile = "GuiDialogProfile";
	horizSizing = "center";
	vertSizing = "center";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellPaneCtrl() {
		profile = "ShellDlgPaneProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "0 0";
		extent = "390 220";
		minExtent = "48 92";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		text = "Kick/Warn Player";
		longTextBuffer = "0";
		maxLength = "255";
		noTitleBar = "0";
		transparent = "0";

		new GuiTextCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "40 40";
			extent = "43 28";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Player";
			longTextBuffer = "0";
			maxLength = "255";
		};

		new ShellPopupMenu(KickReason_Player_Popup) {
			profile = "ShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "90 30";
			extent = "259 49";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			maxPopupHeight = "200";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};

		new GuiTextCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "40 70";
			extent = "43 28";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Message";
			longTextBuffer = "0";
			maxLength = "255";
		};

		new ShellTextEditCtrl() {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "90 60";
			extent = "270 93";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			deniedSound = "InputDeniedSound";
			glowOffset = "9 9";
			variable = "$KickReasonVars::Line1";
		};

		new ShellTextEditCtrl() {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "90 85";
			extent = "270 93";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			deniedSound = "InputDeniedSound";
			glowOffset = "9 9";
			variable = "$KickReasonVars::Line2";
		};

		new GuiTextCtrl() {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "30 130";
			extent = "90 26";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Kick/Warn Delay";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellSliderCtrl(KickReason_Delay_Slider) {
			profile = "ShellSliderProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "110 125";
			extent = "80 24";
			minExtent = "12 24";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "value";
			helpTag = "0";
			range = "2 120";
			ticks = "118";
			usePlusMinus = "0";
			altCommand = "KickReason_Delay_Value.setValue ($KickReason::Delay = mFloatLength (KickReason_Delay_Slider.value,0));";
		};
		new GuiTextCtrl(KickReason_Delay_Value) {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "190 130";
			extent = "30 22";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			variable = "$KickReason::Delay";
		};

		new ShellToggleButton() {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "210 125";
			extent = "140 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Bottom/Center Message";
			longTextBuffer = "0";
			maxLength = "255";
			variable = "$KickReason::Bottom";
		};

		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "30 160";
			extent = "100 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Warn";
			simpleStyle = "0";
			command = "KickWithAReason(true);";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "145 160";
			extent = "100 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Kick";
			simpleStyle = "0";
			command = "KickWithAReason(false);";
		};
		new ShellBitmapButton() {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "260 160";
			extent = "100 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Cancel";
			simpleStyle = "0";
			command = "HideKickReasonGui();";
		};

	};

};
//--- OBJECT WRITE END ---
}
